﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls;
using System.Diagnostics;

namespace HorisontalScollIntoView
{
	public partial class MainPage : UserControl
	{
		GridViewScrollViewer scroll;
		private bool needsToScroll;
		private double horizontalOffset;

		public MainPage()
		{
			InitializeComponent();
			this.needsToScroll = true;

			this.SampleGrid.AutoGeneratingColumn += new EventHandler<GridViewAutoGeneratingColumnEventArgs>(SampleGrid_AutoGeneratingColumn);
			this.SampleGrid.Items.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(Items_CollectionChanged);

			this.DataContext = (from c in Enumerable.Range(0, 10)
								select new Data
									{
										Property1 = c,
										Property2 = c,
										Property3 = c,
										Property4 = c,
										Property5 = c,
										Property6 = c,
										Property7 = c,
										Property8 = "some data" + c,
										Property9 = "some data" + c,
										Property10 = "some data" + c,
										Property11 = "some data" + c,
										Property12 = "some data" + c,
										Property13 = "some data" + c,
										Property14 = "some data" + c,
										Property15 = "some data" + c,
										Property16 = "some data" + c,
										Property17 = "some data" + c,
										Property18 = "some data" + c,
										Property19 = "some data" + c,
										Property20 = "some data" + c
									}).ToList();
		}

		void SampleGrid_AutoGeneratingColumn(object sender, GridViewAutoGeneratingColumnEventArgs e)
		{
			e.Column.Width = new GridViewLength(200, GridViewLengthUnitType.Pixel);
		}

		void Items_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
		{

		}

		void SampleGrid_LayoutUpdated(object sender, EventArgs e)
		{
			Debug.WriteLine(scroll.ContentHorizontalOffset);
		}

		private void SampleGrid_Loaded(object sender, RoutedEventArgs e)
		{

		}

		private void SampleGrid_DataLoaded(object sender, EventArgs e)
		{
			scroll = this.SampleGrid.ChildrenOfType<GridViewScrollViewer>().First();
			scroll.ScrollToHorizontalOffset(600.0);
		}

		void SampleGrid_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
		{
			Debug.WriteLine(e.PropertyName);
		}


	}
	public class Data
	{
		public int Property1 { get; set; }
		public int Property2 { get; set; }
		public int Property3 { get; set; }
		public int Property4 { get; set; }
		public int Property5 { get; set; }
		public int Property6 { get; set; }
		public int Property7 { get; set; }
		public string Property8 { get; set; }
		public string Property9 { get; set; }
		public string Property10 { get; set; }
		public string Property11 { get; set; }
		public string Property12 { get; set; }
		public string Property13 { get; set; }
		public string Property14 { get; set; }
		public string Property15 { get; set; }
		public string Property16 { get; set; }
		public string Property17 { get; set; }
		public string Property18 { get; set; }
		public string Property19 { get; set; }
		public string Property20 { get; set; }

	}
}
